# coding: utf-8

"""
    rokka.io

    digital image processing done right. [Documentation](https://rokka.io/documentation). [Changelog](https://api.rokka.io/changelog.md).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from rokka_client_codegen.models.organization_options import OrganizationOptions  # noqa: F401,E501


class Organization(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'display_name': 'str',
        'name': 'str',
        'billing_email': 'str',
        'options': 'OrganizationOptions',
        'created': 'datetime',
        'master_organization': 'str'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'display_name',
        'name': 'name',
        'billing_email': 'billing_email',
        'options': 'options',
        'created': 'created',
        'master_organization': 'master_organization'
    }

    def __init__(self, id=None, display_name=None, name=None, billing_email=None, options=None, created=None, master_organization=None):  # noqa: E501
        """Organization - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._display_name = None
        self._name = None
        self._billing_email = None
        self._options = None
        self._created = None
        self._master_organization = None
        self.discriminator = None

        self.id = id
        self.display_name = display_name
        self.name = name
        self.billing_email = billing_email
        if options is not None:
            self.options = options
        if created is not None:
            self.created = created
        if master_organization is not None:
            self.master_organization = master_organization

    @property
    def id(self):
        """Gets the id of this Organization.  # noqa: E501


        :return: The id of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Organization.


        :param id: The id of this Organization.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this Organization.  # noqa: E501


        :return: The display_name of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this Organization.


        :param display_name: The display_name of this Organization.  # noqa: E501
        :type: str
        """
        if display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def name(self):
        """Gets the name of this Organization.  # noqa: E501

        Web safe, using in routes and api calls  # noqa: E501

        :return: The name of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Organization.

        Web safe, using in routes and api calls  # noqa: E501

        :param name: The name of this Organization.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def billing_email(self):
        """Gets the billing_email of this Organization.  # noqa: E501


        :return: The billing_email of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._billing_email

    @billing_email.setter
    def billing_email(self, billing_email):
        """Sets the billing_email of this Organization.


        :param billing_email: The billing_email of this Organization.  # noqa: E501
        :type: str
        """
        if billing_email is None:
            raise ValueError("Invalid value for `billing_email`, must not be `None`")  # noqa: E501

        self._billing_email = billing_email

    @property
    def options(self):
        """Gets the options of this Organization.  # noqa: E501


        :return: The options of this Organization.  # noqa: E501
        :rtype: OrganizationOptions
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this Organization.


        :param options: The options of this Organization.  # noqa: E501
        :type: OrganizationOptions
        """

        self._options = options

    @property
    def created(self):
        """Gets the created of this Organization.  # noqa: E501


        :return: The created of this Organization.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this Organization.


        :param created: The created of this Organization.  # noqa: E501
        :type: datetime
        """

        self._created = created

    @property
    def master_organization(self):
        """Gets the master_organization of this Organization.  # noqa: E501

        Billing will agregate all sub organizations and bill the master organization.  # noqa: E501

        :return: The master_organization of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._master_organization

    @master_organization.setter
    def master_organization(self, master_organization):
        """Sets the master_organization of this Organization.

        Billing will agregate all sub organizations and bill the master organization.  # noqa: E501

        :param master_organization: The master_organization of this Organization.  # noqa: E501
        :type: str
        """

        self._master_organization = master_organization

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Organization):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
